name: Deploy to SFTP Server

on:
  push:
    branches: [main]

permissions:
  contents: read
  pages: write
  id-token: write

jobs:
  build:
    env:
      RUNNER_TOOL_CACHE: '/toolcache'
    runs-on: ubuntu-latest
    steps:
      - name: 🔄 Checkout code
        uses: actions/checkout@v3

      - name: 📦 Install Git LFS
        run: |
          apt update && apt install git-lfs zstd

      - name: 🔢 Calculate cache IDs
        run: |
          # Calculate cache IDs for Git LFS and PNPM
          git lfs ls-files -l | cut -d' ' -f1 | sort > .lfs-assets-id
          LFS_CACHE_ID=$(cat .lfs-assets-id | md5sum)-v1
          PNPM_CACHE_ID=$(cat pnpm-lock.yaml | md5sum)-v1
          echo "LFS_CACHE_ID=$LFS_CACHE_ID" >> $GITHUB_ENV
          echo "PNPM_STORE_PATH=$(pnpm store path)" >> $GITHUB_ENV
          echo "PNPM_CACHE_ID=$PNPM_CACHE_ID" >> $GITHUB_ENV

      - name: 🗄️ Cache Git LFS objects
        uses: actions/cache@v4
        with:
          path: .git/lfs
          key: ${{ runner.os }}-lfs-${{ env.LFS_CACHE_ID }}

      - name: 📥 Install Node.js
        uses: actions/setup-node@v4
        with:
          node-version: 20

      - name: 📦 Install PNPM
        uses: pnpm/action-setup@v3
        id: pnpm-install
        with:
          version: 8
          node_version: 20
          run_install: false

      - name: 🛠️ Cache PNPM dependencies
        uses: actions/cache@v4
        with:
          path: ${{ env.STORE_PATH }}
          key: ${{ runner.os }}-pnpm-store-${{ hashFiles('**/pnpm-lock.yaml') }}

      - name: 🔄 Pull Git LFS files
        run: git lfs pull

      - name: 🏗️ Build site
        run: |
          # Install dependencies, build, and generate site output
          pnpm i && pnpm build

      - name: 🚀 Deploy files via SFTP
        uses: pressidium/lftp-mirror-action@v1
        with:
          host: ${{ secrets.FTP_HOST }}
          port: ${{ secrets.FTP_PORT || 21 }}
          user: ${{ secrets.FTP_USERNAME }}
          pass: ${{ secrets.FTP_PASSWORD }}
          onlyNewer: true
          parallel: '4'
          settings: 'sftp:auto-confirm=yes'
          localDir: 'dist'
          remoteDir: '/share/new-website'
          options: '--verbose'

